/* 
 * winCloser Gnome-panel applet
 *
 * Author: Jochen Baier, email@jochen-baier.de
 * License: GPL
 * 
 */ 

#include <gnome.h>
#include <panel-applet.h>
#include <panel-applet-gconf.h>
#define WNCK_I_KNOW_THIS_IS_UNSTABLE 1  
#include <libwnck/libwnck.h>
#include "config.h"
#include "common.h"

#include <gdk/gdkx.h>
#include <gdk/gdk.h>  
#include <X11/Xatom.h> 

void close_current_workspace (Applet *applet, gboolean kill) {

  if (debug) printf ("close current workspace\n");

  WnckScreen *screen=wnck_screen_get_default();
  wnck_screen_force_update(screen);
  WnckWorkspace *workspace=wnck_screen_get_active_workspace (screen);

  g_assert (workspace != NULL);

  GList*  win_list=wnck_screen_get_windows (wnck_screen_get_default());  

  WnckWindow *window;
  g_list_foreach_data (win_list, window, WnckWindow*) {

    if (wnck_window_is_on_workspace (window, workspace) && 
        wnck_window_get_window_type (window) == WNCK_WINDOW_NORMAL) {
      if (debug) printf ("win_name %s\n", wnck_window_get_name (window));

      Window xid=  wnck_window_get_xid (window);
      if (debug) printf ("xid: %d\n", (int) xid);

      if (kill) {
        gdk_error_trap_push ();
		    XKillClient (GDK_DISPLAY(), xid); 
		    gdk_flush ();
		    gdk_error_trap_pop ();
      }  else {
        wnck_window_close (window, gtk_get_current_event_time());
      }

     }

   }

}

void close_all_workspace (Applet *applet) {

  if (debug) printf ("close on all workspace\n");

  WnckScreen *screen=wnck_screen_get_default();
  wnck_screen_force_update(screen);

  WnckWorkspace *start_workspace=wnck_screen_get_active_workspace (screen);
  GList*  win_list=wnck_screen_get_windows (wnck_screen_get_default());

  WnckWindow *window;
  g_list_foreach_data (win_list, window, WnckWindow*) {
    if ( wnck_window_get_window_type (window) == WNCK_WINDOW_NORMAL) {
     if (debug) printf ("win name:  %s\n", wnck_window_get_name (window)); 
     wnck_window_move_to_workspace (window, start_workspace);
    }
  }

  wnck_screen_force_update(screen);
  GList*  win_list2=wnck_screen_get_windows (wnck_screen_get_default()); 

  WnckWindow *window2;   
  g_list_foreach_data (win_list2, window2, WnckWindow*) {
    if ( wnck_window_get_window_type (window2) == WNCK_WINDOW_NORMAL) {
       if (debug) printf ("close name:  %s\n", wnck_window_get_name (window2)); 
      wnck_window_close (window2, gtk_get_current_event_time());
    }
  }

}  

